(***************************************************************************)
(*                                                                         *)
(*                  UNIDAD PARA GESTION DE FICHEROS                        *)
(*                      ELCHE 1 OCTUBRE DE 1992                            *)
(*                  AUTOR: FRANCISCO JOSE MORA LIZAN                       *)
(*                                                                         *)
(*                      ES LLAMADA DESDE PL.PAS                            *)
(*                                                                         *)
(***************************************************************************)
Unit Ficheros;
Interface
Uses Crt,Win,Dos,Utiles,Tipos;

Const
 MaxElem=512; (* Total de elementos de la lista de ficheros *)

Var
 Fich:SearchRec;
 path:PATHSTR;
 dir:DIRSTR;
 nombre:NAMESTR;
 extension:EXTSTR;

 Directorio:ARRAY [1..MaxElem] OF STRING[14];
 indice,i,PosicionVentanaY:INTEGER;

 Camino:ARRAY ['A'..'Z'] OF STRING;
 Unidad,tecla:CHAR;

 DirectorioActual,Operacion,NombreFichero,NombreFicheroDefecto:STRING;

Procedure Inicializar_menu_ficheros;
Procedure Gestor_de_ficheros;

Implementation

{ Procedimiento para ordenar el vector directorio}
Procedure Sort (Iz,De:Integer);
Var
 i,j:Integer;
 x,w:STRING[14];
Begin
 i:=Iz;
 j:=De;
 x:=directorio[(Iz+De) Div 2];
 Repeat
  While directorio[i]<x do
   Inc (i);
  While x<directorio[j] Do
   Dec (j);
  If i<=j Then
   Begin
    w:=directorio[i];
    directorio[i]:=directorio[j];
    directorio[j]:=w;
    Inc (i);
    Dec (j)
   End
 Until i>j;
 If Iz<j Then Sort (Iz,J);
 If i<De Then Sort (i,De)
End;

{ Procedimiento para cargar el direcorio actual }
Procedure CargarDirectorio(path:STRING;inicio:integer;es_directorio:boolean);
Var
 pos_relx,posrely,pos_abs:INTEGER;
 i:INTEGER;
 cadenasi,cadenadi:STRING;
 Regs:REGISTERS;
Begin
 indice:=inicio;
 If es_directorio then
  FindFirst (path+'*.*',Anyfile,Fich)
 else
  FindFirst (path+NombreFichero,Archive+Directory,Fich);
 (***** COMPROBACION DE POSIBLES ERRORES *****)
 IF (DosError<>0) then
  Begin
   If NOT((DosError=18) AND (NOT(es_directorio))) THEN
    Begin
     GOTOXY(1,1);
     IF (WindMax-WindMin)>1048 Then
      Mensaje(20,PosicionVentanaY+8,74,PosicionVentanaY+13,Doserror,'')
     Else
      Mensaje(20,PosicionVentanaY+5,74,PosicionVentanaY+10,Doserror,'');
     tecla:=#27;
     Exit;
    End;
  End
 Else
  Begin
   { Cambia la unidad y el camino (path) actual }
   unidad:=path[1];
   camino[unidad]:=path;
   (***** LECTURA DE LOS FICHEROS DEL DIRECTORIO *****)
   Repeat
    If ((fich.attr=16) AND (es_directorio)) OR ((es_directorio=FALSE) AND (fich.attr<>16)) THEN
     Begin
      { Ajusta la longitud y el formato de los nombres de ficheros y directorios }
      If (Fich.name<>'..') THEN
       Inc (indice);
      i:=Pos('.', Fich.Name);
      If i>1 then
       Begin
        nombre:=Copy(Fich.Name, 1,i-1);
        extension:=Copy(Fich.Name,i+1,3);
        extension:='.'+extension+'   ';
       end
      else
       Begin
        nombre:=Fich.Name;
        extension:='    ';
       end;
      nombre:=nombre+'        ';
      Fich.name:=nombre+extension;
      directorio[indice]:=Fich.name;
      if Fich.Attr=16 THEN
       directorio[indice]:='\'+directorio[indice]+' '
      else
       directorio[indice]:=directorio[indice]+'  ';
     end;
    FindNext (Fich); { Busca el siguiente fichero o directorio }
   Until Doserror<>0;
   SORT(inicio+1,indice); { Ordena el directorio en orden alfabtico ascendente }
  End;
 If NOT(es_directorio) Then
  { Cuando ha cargado los ficheros hace una llamada recursiva para cargar los directorios }
  CargarDirectorio(path,indice,TRUE)
 Else
  { Carga el nombre de todas las unidades lgicas }
  Begin
    cadenadi:='                  ';
    For i:=65 TO 90 do
     Begin
      cadenasi:=CHR(i)+':';
      with Regs do
       Begin
        ax:=$2906;
        ds:=SEG(CADENASI);
        es:=SEG(CADENADI);
        si:=OFS(cadenasi)+1;
        di:=OFS(cadenadi)+1;
       End;
      MSDOS(regs);
      { Si existe esa unidad lgica la pone en el vector directorio }
      If (REGS.AL<>$FF) AND (cadenasi[1]<>unidad) Then
       Begin
        Inc(indice);
        directorio[indice]:='['+cadenasi+']          ';
       End;
     End;
  End;
End;

{ Procedimiento para elegir un fichero a travs de ventanas }
Procedure MostrarDirectorio(CaminoPosible:STRING);
Var
 pos_relx,pos_rely,pos_abs:INTEGER;
 i,j:INTEGER;
 CadenaAux:STRING;
Begin
 CargarDirectorio(CaminoPosible,0,FALSE);
 IF tecla<>#27 Then  { Si nos podemos situar en CaminoPosible }
  BEGIN
   OCULTAR;
   AbrirVentana(' '+camino[unidad]+NombreFichero+' ',17,PosicionVentanaY+5,79,PosicionVentanaY+16,MarcoB);
   clrscr;
   { Inicializacin de valores }
   j:=1;
   pos_abs:=1;
   pos_relx:=1;
   pos_rely:=1;

   { Escritura en pantalla de los primeros 40 ficheros }
   While (j<=40) And (j<=indice) DO
    begin
     write(' ');
     write(Directorio[j]);
     If ((j MOD 4)=0) AND (j<40) THEN
      Writeln;
     Inc(j)
    end;
   writestr(1,1,directorio[1],112);

   { Movimiento con cursores, inicio, fin, etc... }
   Repeat
    { Escritura de la linea en la que estamos situados }
    For j:=1 TO 4 DO
     if j=pos_relx Then { Escritura en inverso }
      writestr(15*(j-1)+1,pos_rely,' '+directorio[pos_abs-pos_relx+j],112)
     else
       If pos_abs-pos_relx+j<=indice Then  { Escritura normal }
        writestr(15*(j-1)+1,pos_rely,' '+directorio[pos_abs-pos_relx+j],7);
   {
    gotoxy(1,1);
    write('*',pos_relx:2,'*',pos_rely:2,'*',pos_abs:2,'*');
   }

    tecla:=READKEY;
    IF tecla=#0 THEN
     tecla:=READKEY;
    Case tecla of
      #80: Begin
            i:=indice Mod 4;
            If i=0 Then
             i:=4;
            If pos_abs+i<=indice Then { Cursor abajo }
             Begin
              writestr(15*(pos_relx-1)+1,pos_rely,' '+directorio[pos_abs],7);
              pos_abs:=pos_abs+4;
              If pos_abs>indice Then
               Begin
                pos_abs:=indice;
                pos_relx:=(indice mod 4)
               End;
              if pos_rely<10 THEN
               Inc(pos_rely)
              else
               begin
                GOTOXY(61,10);
                writeln;
               end;
             end;
           End;
      #72: If pos_abs>4 Then { Cursor arriba }
            begin
             writestr(15*(pos_relx-1)+1,pos_rely,' '+directorio[pos_abs],7);
             pos_abs:=pos_abs-4;
             if pos_rely>1 THEN
              Dec(pos_rely)
             else
              begin
               GOTOXY(1,1);
               insline;
              end;
            end;
      #77: If pos_abs<indice Then { Cursor derecho }
            begin
             writestr(15*(pos_relx-1)+1,pos_rely,' '+directorio[pos_abs],7);
             pos_abs:=pos_abs+1;
             if pos_relx<4 THEN
              Inc(pos_relx)
             else
              begin
               pos_relx:=1;
               if pos_rely<10 THEN
                Inc(pos_rely)
               else
                begin
                 GOTOXY(60,10);
                 writeln;
                end;
              end;
            end;
      #75: If pos_abs>1 Then { Cursor izquierdo }
            begin
             writestr(15*(pos_relx-1)+1,pos_rely,' '+directorio[pos_abs],7);
             pos_abs:=pos_abs-1;
             if pos_relx>1 THEN
              Dec(pos_relx)
             else
              begin
               pos_relx:=4;
               if pos_rely>1 THEN
                Dec(pos_rely)
               else
                begin
                 GOTOXY(1,1);
                 insline;
                end;
              end;
            end;
      #71: Begin { Inicio }
            clrscr;
            j:=1;
            pos_abs:=1;
            pos_relx:=1;
            pos_rely:=1;
            While (j<=40) And (j<=indice) DO
             begin
              write(' ');
              write(Directorio[j]);
              If ((j MOD 4)=0) AND (j<40) THEN
              Writeln;
              Inc(j)
             end;
            writestr(1,1,directorio[1],112);
           End;
      #79: Begin { Fin }
            clrscr;
            pos_relx:=(indice MOD 4);
            if pos_relx=0 THEN
             pos_relx:=4;
            pos_abs:=indice-40+4-Pos_relx+1;
            If pos_abs<1 Then
             pos_abs:=1;
            If indice>36 THEN
             pos_rely:=10
            Else
             pos_rely:=((indice DIV 4) MOD 10);
            j:=1;
            While (j<=40) And (j+pos_abs<=indice+1) DO
             begin
              write(' ');
              write(Directorio[j+pos_abs-1]);
              If ((j MOD 4)=0) AND (j<40) THEN
               Writeln;
              Inc(j)
             end;
            pos_abs:=indice;
           End;
      #73: Begin { Pgina arriba }
            clrscr;
            pos_abs:=pos_abs-40-pos_relx+1;
            If pos_abs<1 Then
              pos_abs:=1;
            pos_rely:=1;
            j:=1;
            While (j<=40) And (j+pos_abs<=indice+1) DO
             begin
              write(' ');
              write(Directorio[j+pos_abs-1]);
              If ((j MOD 4)=0) AND (j<40) THEN
               Writeln;
              Inc(j)
             end;
            pos_abs:=pos_abs+pos_relx-1;
           End;
      #81: Begin { Pgina abajo }
            Clrscr;
            If (pos_abs+40-pos_relx+1)<=indice Then
             Begin
              pos_abs:=pos_abs+40-pos_relx+1;
              pos_rely:=1;
              j:=1;
              While (j<=40) And (j+pos_abs<=indice+1) DO
               begin
                write(' ');
                write(Directorio[j+pos_abs-1]);
                If ((j MOD 4)=0) AND (j<40) THEN
                 Writeln;
                Inc(j)
               end;
              pos_abs:=pos_abs+pos_relx-1;
              If pos_rely=10 Then
               pos_abs:=pos_abs+36+pos_relx-1;
              If pos_abs>Indice Then
               Begin
                pos_abs:=Indice;
                pos_relx:=(indice MOD 4);
                if pos_relx=0 THEN
                 pos_relx:=4;
               END;
             End
            Else
             Begin
              pos_relx:=(indice MOD 4);
              if pos_relx=0 THEN
               pos_relx:=4;
              pos_abs:=indice-40+4-pos_relx+1;
              If pos_abs<1 Then
               pos_abs:=1;
              If indice>36 THEN
               pos_rely:=10
              Else
               pos_rely:=((indice DIV 4) MOD 10);
              j:=1;
              While (j<=40) And (j+pos_abs<=indice+1) DO
               begin
                write(' ');
                write(Directorio[j+pos_abs-1]);
                If ((j MOD 4)=0) AND (j<40) THEN
                 Writeln;
                Inc(j)
               end;
              pos_abs:=indice;
             End;
            
           End;

      #13: { Si escogemos un directorio o una unidad lgica }
           If (directorio[pos_abs][1]='\') OR (directorio[pos_abs][1]='[') Then
            Begin
             If directorio[pos_abs][1]='\' THEN
              Begin
               CadenaAux:=directorio[pos_abs];
               DELETE(CadenaAux,1,1);
               DELETE(CadenaAux,POS(' ',CadenaAux),LENGTH(CadenaAux));
               IF pos('..',CadenaAux)>0 Then
                Begin
                 CaminoPosible:=camino[unidad];
                 DELETE(CaminoPosible,LENGTH(CaminoPosible),1);
                 WHILE CaminoPosible[LENGTH(CaminoPosible)]<>'\' DO
                  DELETE(CaminoPosible,LENGTH(CaminoPosible),1);
                End
               Else
                CaminoPosible:=CaminoPosible+CadenaAux+'\';
              End
             Else
              CaminoPosible:=Camino[directorio[pos_abs][2]];
             CargarDirectorio(CaminoPosible,0,FALSE);
             IF tecla<>#27 Then
              Begin
               CerrarVentana;
               AbrirVentana(' '+camino[unidad]+NombreFichero+' ',17,PosicionVentanaY+5,79,PosicionVentanaY+16,MarcoB);
               CLRSCR;
               j:=1;
               pos_abs:=1;
               pos_relx:=1;
               pos_rely:=1;
               While (j<=40) And (j<=indice) DO
                begin
                 write(' ');
                 write(Directorio[j]);
                 If ((j MOD 4)=0) AND (j<40) THEN
                  Writeln;
                 Inc(j)
                end;
               writestr(1,1,directorio[1],112);
               tecla:=' ';
              End;
            End
    End;{ Del Case }
   Until tecla IN [#27,#13];
   If tecla=#13 Then { Si escogemos un fichero }
    Begin
     NombreFichero:=directorio[pos_abs];
     { Quitamos los espacios en blanco finales }
     For i:=LENGTH(NombreFichero) DOWNTO 1 DO
      if NombreFichero[i]=' ' Then
       DELETE(NombreFichero,i,1);
    End;
  End;
 Mostrar;
End;

{ Procedimiento para Cargar un fichero de disco }
Procedure Cargar(nombre_fichero:STRING);
Var
 fichero:FILE OF TIPO_PROBLEMA_LINEAL;
 error:integer;
Begin
 { Comprobacin si existe este fichero }
 {$I-}
 ASSIGN(fichero,nombre_fichero);
 RESET(fichero);
 {$I+}
 error:=ioresult;
 IF error=0 THEN
  BEGIN
   { Carga fsica del fichero }
   {$I-}
   READ(fichero,Pl);
   CLOSE(fichero);
   {$I+}
   error:=ioresult;
  End;
 If error<>0 Then
  Mensaje(17,PosicionVentanaY+5,70,PosicionVentanaY+10,error,'')
 Else
  seleccion:=0;
END;

{ Procedimiento para grabar datos en un fichero de disco }
Procedure Grabar(nombre_fichero:STRING);
Var
 fichero_aux:FILE;
 fichero:FILE OF TIPO_PROBLEMA_LINEAL;
 error:integer;
Begin
 { Comprobacin si existe otro fichero con ese nombre }
 {$I-}
 Assign(fichero_aux,nombre_fichero);
 Reset(fichero_aux);
 {$I+}
 error:=ioresult;
 IF error=0 THEN
  BEGIN
   Close(fichero_aux);
   AbrirVentana(' '+nombre_fichero+' ya existe. ',17,6,70,8,MarcoB);
   ClrScr;
   Write('           Escribo encima de l (S/N)? ');
   Repeat
    tecla:=UPCASE(READKEY);
   Until tecla IN [#13,#27,'S','N'];
   CerrarVentana;
  END;
 If (tecla=#13) OR (tecla='S') OR (error<>0) Then
  Begin
   { Grabacin fsica del fichero }
   {$I-}
   Assign(fichero,nombre_fichero);
   Rewrite(fichero);
   Write(fichero,Pl);
   Close(fichero);
   {$I+}
   error:=ioresult;
  End;
 If error<>0 Then
  Mensaje(17,PosicionVentanaY+5,70,PosicionVentanaY+10,error,'')
 Else
  seleccion:=0;
End;

{ Procedimiento para borrar un fichero de disco }
Procedure Borrar(nombre_fichero:STRING);
Var
 fichero:FILE;
 error:integer;
Begin
 { Comprobacin si existe otro fichero con ese nombre }
 {$I-}
 Assign(fichero,nombre_fichero);
 Reset(fichero);
 {$I+}
 error:=ioresult;
 If error=0 Then
  Begin
   Close(fichero);
   AbrirVentana(' fichero = '+nombre_fichero+' ',17,6,70,8,MarcoB);
   ClrScr;
   Write(' Est seguro que quiere borrar este fichero (S/N)?');
   Repeat
    tecla:=UPCASE(READKEY);
   Until tecla IN [#13,#27,'S','N'];
   CerrarVentana;
   IF (tecla=#13) OR (tecla='S') THEN
    Begin
     { Grabacin fsica del fichero }
     {$I-}
     Erase(fichero);
     error:=ioresult;
     {$I+}
    End;
  End;
 If error<>0 Then
  Mensaje(17,PosicionVentanaY+5,70,PosicionVentanaY+10,error,'');
END;

Procedure inicializar_menu_ficheros;
BEGIN
 PosicionVentanaY:=4;
 NombreFicheroDefecto:='*.PL';
 NombreFichero:=NombreFicheroDefecto;
 GETDIR(0,DirectorioActual);
 If DirectorioActual[LENGTH(DirectorioActual)]<>'\' THEN
  DirectorioActual:=DirectorioActual+'\';

 { Inicializa el vector camino }
 FOR unidad:='A' TO 'Z' DO
  camino[unidad]:=unidad+':\';
 unidad:=DirectorioActual[1];
 camino[unidad]:=DirectorioActual;

 DEFMENU(' GESTOR DE FICHEROS ',5,PosicionVentanaY,31,PosicionVentanaY+6,MarcoB);
 DEFOPCION('1',' GESTOR DE FICHEROS ','  1) CARGAR FICHERO.','');
 DEFOPCION('2',' GESTOR DE FICHEROS ','  2) GRABAR FICHERO.','');
 DEFOPCION('3',' GESTOR DE FICHEROS ','  3) BORRAR FICHERO.','');
 DEFOPCION('4',' GESTOR DE FICHEROS ','  4) CAMBIAR DIRECTORIO.','');
 DEFOPCION('5',' GESTOR DE FICHEROS ','  5) SALIR.','');
END;

Procedure Gestor_de_ficheros;
Begin

 {
 TEXTCOLOR(7);
 TEXTBACKGROUND(0);
 Clrscr;
 }

 Repeat
  ActivarMenu(' GESTOR DE FICHEROS ');
  Case seleccion of
   1: BEGIN
       operacion:='Cargar';
       NombreFichero:='*.PL';
      END;
   2: operacion:='Grabar';
   3: operacion:='Borrar';
   4: operacion:='Cambiar Directorio Actual';
  End; { Del Case }
  If seleccion IN [1..4] Then
   Begin
    If seleccion<4 Then
      AbrirVentana(' Introduce el nombre del fichero a '+operacion+' ',17,PosicionVentanaY+5,70,PosicionVentanaY+7,MarcoB)
    Else
     Begin
      AbrirVentana(' Cambiar directorio actual ',17,PosicionVentanaY+5,70,PosicionVentanaY+7,MarcoB);
      NombreFichero:=camino[unidad];
     End;
    ClrScr;
    LeerCadena(2,1,50,7,NombreFichero,tecla);
    If (NombreFichero[LENGTH(NombreFichero)]<>'\') AND (seleccion=4) AND (NombreFichero<>'') THEN
     NombreFichero:=NombreFichero+'\';
    CerrarVentana;
    If tecla<>#27 THEN
     Begin
      path:=NombreFichero;
      Fsplit(path,dir,nombre,extension);
      If LENGTH(dir)=0 Then
       dir:=camino[unidad]
      Else
       If dir[2]<>':' Then
        dir:=Unidad+':'+dir;
      FOR i:=1 TO LENGTH(dir) DO
       DIR[i]:=UPCASE(DIR[i]);
      If LENGTH(dir)=2 Then
       dir:=camino[dir[1]];
      If POS('\',dir)>3 Then
       Begin
        DELETE(dir,1,2);
        dir:=camino[unidad]+dir;
       End;
      If (extension='') AND (nombre<>'') THEN
       extension:='.PL';
      NombreFichero:=nombre+extension;
      If NombreFichero='' Then
       NombreFichero:=NombreFicheroDefecto;
      If ((pos('*',NombreFichero)>0) OR (pos('?',NombreFichero)>0)) AND (seleccion<4) THEN
       Begin
        MostrarDirectorio(dir);
        CerrarVentana;
       End
      Else
       Begin
        If seleccion IN [2,4] Then
         FindFirst (dir+'*.*',Archive+Directory,Fich)
        Else
         FindFirst (dir+NombreFichero,Archive+Directory,Fich);
        (***** COMPROBACION DE POSIBLES ERRORES *****)
        IF (DosError<>0) AND ((seleccion<>2) AND (Doserror<>18)) then
         Begin
          Mensaje(20,PosicionVentanaY+5,74,PosicionVentanaY+10,Doserror,'');
          tecla:=#27;
         End
        Else
         Begin
          { Cambia la unidad y el camino (path) actual }
          if dir[2]=':' Then
           unidad:=dir[1];
          camino[unidad]:=dir;
         End;
       End;
      If tecla<>#27 Then
       Case seleccion OF
        1: CARGAR(camino[unidad]+NombreFichero);
        2: GRABAR(camino[unidad]+NombreFichero);
        3: BORRAR(camino[unidad]+NombreFichero);
       End;
     End;
   End;
 Until seleccion IN [5,0];
 DesactivarMenu;
 TEXTATTR:=7;
End;
Begin
End.
