(***************************************************************************)
(*                                                                         *)
(*           PROGRAMA RESOLUCION GRAFICA DE PROBLEMAS LINEALES             *)
(*                      ALICANTE 1 OCTUBRE DE 1999                         *)
(*                              DCCIA                                      *)
(*                      FRANCISCO JOSE MORA LIZAN                          *)
(*                                                                         *)
(*                     LENGUAJE TURBO PASCAL 5.5                           *)
(*                     SISTEMA OPERATIVO  MS-DOS                           *)
(*                                                                         *)
(***************************************************************************)

PROGRAM RGPL;
{$A+}              { UTILIZA INSTRUCCIONES PARA 80286 }
USES DOS,CRT,PRINTER,WIN,Utiles,Ayuda,Ficheros,TIPOS,Rg;

{ Parmetro para regular la altura de los datos su entrada y muestra }
CONST
 posicion=3;

{ Procedimiento para inicializar un problema lineal }
PROCEDURE INICIALIZAR_PL;
VAR
 i,j:BYTE;
BEGIN
 Pl.primal:=TRUE;
 Pl.Funcion_objetivo.Minimizar:=1;
 FOR i:=1 TO 3 DO
  BEGIN
   Pl.Funcion_objetivo.C[i]:=0;
   Pl.Restriccion[i].D:=0;
   Pl.restriccion[i].igualdad:=0;
   FOR j:=1 TO 3 DO
    Pl.Restriccion[j].A[i]:=0;
  End;
End;

{ Procedimiento que nos pide verificacin antes de inicilizar el problema lineal }
PROCEDURE INICIALIZAR_PL_CON_VERIFICACION;
VAR
 tecla:CHAR;
BEGIN
 CLRSCR;
 GOTOXY(18,8);
 WRITE(' PULSA I PARA INICIALIZAR EL PROBLEMA LINEAL');
 GOTOXY(19,9);
 WRITE('U OTRA TECLA PARA VOLVER AL MENU PRINCIPAL.');
 tecla:=UPCASE(READKEY);
 IF tecla='I' THEN
  BEGIN
   Inicializar_Pl;
   CLRSCR;
   GOTOXY(28,8);
   WRITE('PROBLEMA LINEAL INICIALIZADO.');
   GOTOXY(19,9);
   WRITE('PULSA UNA TECLA PARA VOLVER AL MENU PRINCIPAL.');
   tecla:=READKEY
  END;
END;

{ Procedimiento para mostrar los datos de un Pl por pantalla }
PROCEDURE MOSTRAR_PL_PANTALLA;
VAR
 i,j:INTEGER;
 x,y:INTEGER;
BEGIN
 CLRSCR;
 GOTOXY(1,posicion+4);
 WRITE('FUNCION OBJ.:   ');
 CASE Pl.Funcion_objetivo.Minimizar of
  1:WRITE('+MIN');
  2:WRITE('-MIN');
  3:WRITE('+MAX');
  4:WRITE('-MAX');
 End; { Del Case }
 WRITE(' Z=');
 FOR i:=1 TO 3 DO
    WRITE(Real_a_cadena(Pl.Funcion_objetivo.C[i],10,TRUE,TRUE),'X',i:1,' ');
 WRITELN;
 WRITELN;
 FOR i:=1 TO 3 DO
  BEGIN
   WRITE('RESTRICCION',i:2,'......... ');
   FOR j:=1 TO 3 DO
    WRITE(Real_a_cadena(Pl.Restriccion[i].A[j],10,TRUE,TRUE),'X',j:1,' ');
   IF Pl.restriccion[i].igualdad=0 THEN
    WRITE('>= ')
   ELSE
    WRITE('<= ');
   WRITELN(Real_a_cadena(Pl.Restriccion[i].D,10,TRUE,TRUE));
  END;
 WRITELN('Xi>=0 Vi=1..3');
END;

{ Procedimiento para mostrar los datos de un Pl por impresora }
PROCEDURE MOSTRAR_PL_IMPRESORA;
VAR
 i,j:INTEGER;
 x,y:INTEGER;
 escape:BOOLEAN;
BEGIN
 AbrirVentana(' IMPRIMIR MANUAL ',23,12,56,20,MarcoB);
 CLRSCR;
 WRITELN;
 WRITELN('     PREPARA LA IMPRESORA!');
 WRITELN('              Y');
 WRITELN('        PULSA UNA TECLA.');
 WRITELN;
 WRITE('    <ESC> ABORTAR IMPRESION.');

 tecla:=READKEY;

 CLRSCR;
 WRITELN;
 WRITELN;
 WRITELN('      ESTOY IMPRIMIENDO !');

 escape:=(tecla=#27);
 IF escape=FALSE THEN
  BEGIN
   If Pl.primal Then
    cadena_aux:='PRIMAL'
   Else
    cadena_aux:='DUAL';
   FOR i:=1 TO 80 DO
    WRITE(LST,'-');
   WRITELN(LST);
   WRITELN(LST,'MOSTRAR DATOS DEL P.L '+cadena_aux+' POR IMPRESORA');
   WRITELN(LST);
   WRITE(LST,'FUNCION OBJ.:   ');
   CASE Pl.Funcion_objetivo.Minimizar of
    1:WRITE(LST,'+MIN');
    2:WRITE(LST,'-MIN');
    3:WRITE(LST,'+MAX');
    4:WRITE(LST,'-MAX');
   End; { Del Case }
   WRITE(LST,' Z=');
   FOR i:=1 TO 3 DO
    WRITE(LST,Real_a_cadena(Pl.Funcion_objetivo.C[i],10,TRUE,TRUE),'X',i:1,' ');
   WRITELN(LST);
   WRITELN(LST);
   FOR i:=1 TO 3 DO
    BEGIN
     WRITE(LST,'RESTRICCION',i:2,'......... ');
     FOR j:=1 TO 3 DO
      WRITE(LST,Real_a_cadena(Pl.Restriccion[i].A[j],10,TRUE,TRUE),'X',j:1,' ');
     IF Pl.restriccion[i].igualdad=0 THEN
      WRITE(LST,'>= ')
     ELSE
      WRITE(LST,'<= ');
     WRITELN(LST,Real_a_cadena(Pl.Restriccion[i].D,10,TRUE,TRUE));
    END;
   WRITELN(LST);
   WRITELN(LST,'Xi>=0 Vi=1..3');
   FOR i:=1 TO 80 DO
    WRITE(LST,'-');
   WRITELN(LST);
  END;

 IF escape=TRUE THEN
  BEGIN
   CLRSCR;
   WRITELN;
   WRITELN;
   WRITELN('     IMPRESION CANCELADA !');
   WRITELN;
   WRITE  ('        PULSA UNA TECLA.');
  END
 ELSE
  BEGIN
   CLRSCR;
   WRITELN;
   WRITELN;
   WRITELN('     IMPRESION FINALIZADA !');
   WRITELN;
   WRITE  ('        PULSA UNA TECLA.');
  END;
 tecla:=READKEY;
 CerrarVentana;
END;

{ Procedimiento para introducir los datos de un Pl por teclado }
PROCEDURE LEER_PL;
VAR
 i,j:INTEGER;
 x,y:INTEGER;
BEGIN
 MOSTRAR_PL_PANTALLA;
 If Pl.primal Then
  cadena_aux:='PRIMAL'
 Else
  cadena_aux:='DUAL';
 WRITESTR(23,posicion+1,'INTRODUCCION DE DATOS DEL P.L. '+cadena_aux,7);
 GOTOXY(22,19);
 WRITE('PULSA ESCAPE PARA VOLVER AL MENU PRINCIPAL');
 x:=1;
 y:=1;
 Repeat
  If y=1 Then
   If x<4 Then
    LeerNumero(x*14+11,posicion+4,10,7,Pl.Funcion_objetivo.C[x],tecla)
   Else
    Begin
     ActivarMenu(' OBJETIVO ');
     DesactivarMenu;
     If seleccion<>0 Then
      Begin
       Pl.Funcion_objetivo.Minimizar:=seleccion;
       GOTOXY(17,posicion+4);
       CASE seleccion of
        1:WRITE('+MIN');
        2:WRITE('-MIN');
        3:WRITE('+MAX');
        4:WRITE('-MAX');
       End; { Del Case }
      End;
     tecla:=#13;
     x:=0;
    End
  Else
   If x<4 Then
    LeerNumero(x*14+11,posicion+y+4,10,7,Pl.Restriccion[y-1].A[x],tecla)
   Else
    If x=4 THEN
     Begin
      gotoxy(x*14+10,posicion+y+4);
      tecla:=READKEY;
      If tecla=#0 Then
       tecla:=READKEY
      else
       If (tecla='>') OR (tecla='<') Then
        Begin
         If (tecla='>') Then
          Pl.restriccion[y-1].igualdad:=0
         else
          Pl.restriccion[y-1].igualdad:=1;
         WRITE(tecla);
         tecla:=#13;
        End;
     End
    else
     LeerNumero(x*14,posicion+y+4,10,7,Pl.Restriccion[y-1].D,tecla);
  Case tecla of
   #80:If y<4 Then
       y:=y+1
      Else
       y:=1;
   #72:If y>1 Then
       y:=y-1
      Else
       y:=4;
   #77:If x<5 Then
       x:=x+1
      Else
       x:=1;
   #75:If x>1 Then
       x:=x-1
      Else
       x:=5;
   #13:Begin
        x:=x+1;
        If x>5 Then
         Begin
          x:=1;
          y:=y+1;
         End;
        If y>4 Then
         y:=1;
       End;
  End; { Del Case }
 Until tecla=#27;
END;

{ Procedimiento que convierte un problema PRIMAL en DUAL }
PROCEDURE PASO_A_DUAL;
VAR
 Pl_aux:TIPO_PROBLEMA_LINEAL;
 i,j:INTEGER;
BEGIN
 If Pl.primal Then
  Begin
   CLRSCR;
   GOTOXY(19,8);
   WRITE('PULSA D PARA PASAR A SU FORMA DUAL EL P.L');
   GOTOXY(19,9);
   WRITE('U OTRA TECLA PARA VOLVER AL MENU PRINCIPAL.');
   tecla:=UPCASE(READKEY);
   IF tecla='D' THEN
    BEGIN
     { Paso la funcin objetivo a la forma minimizar }
     If Pl.funcion_objetivo.minimizar>2 Then
      Begin
       If Pl.funcion_objetivo.minimizar=3 Then
        Pl.funcion_objetivo.minimizar:=2
       Else
        Pl.funcion_objetivo.minimizar:=1;
       For i:=1 TO 3 DO
        Pl.funcion_objetivo.c[i]:=-Pl.funcion_objetivo.c[i];
      End;
     { Conversin a forma standard }
     For i:=1 TO 3 DO
      IF Pl.restriccion[i].IGUALDAD=1 THEN
       BEGIN
        Pl.restriccion[i].IGUALDAD:=0;
        Pl.restriccion[i].a[1]:=-Pl.restriccion[i].a[1];
        Pl.restriccion[i].a[2]:=-Pl.restriccion[i].a[2];
        Pl.restriccion[i].a[3]:=-Pl.restriccion[i].a[3];
        Pl.restriccion[i].d:=-Pl.restriccion[i].d;
       END;

     { Aplicacin del teorema de la dualidad }
     Pl_aux.funcion_objetivo.minimizar:=Pl.funcion_objetivo.minimizar+2;

     For i:=1 TO 3 DO
      Begin
       Pl_aux.restriccion[i].igualdad:=1;
       Pl_aux.restriccion[i].d:=Pl.funcion_objetivo.c[i];
       Pl_aux.funcion_objetivo.c[i]:=Pl.restriccion[i].d;
       For j:=1 TO 3 DO
        Pl_aux.restriccion[i].a[j]:=Pl.restriccion[j].a[i];
      End;
     Pl:=Pl_aux;
     Pl.primal:=FALSE;
    End;
  End;
 If NOT(Pl.primal) Then
  Begin
   CLRSCR;
   GOTOXY(28,8);
   WRITE('YA TIENES LA FORMA DUAL DEL P.L');
   GOTOXY(19,9);
   WRITE('PULSA UNA TECLA PARA VOLVER AL MENU PRINCIPAL.');
   tecla:=READKEY
  END;
END;

{ Procedimiento para pasar un Pl de DUAL a PRIMAL }
PROCEDURE PASO_A_PRIMAL;
VAR
 Pl_aux:TIPO_PROBLEMA_LINEAL;
 i,j:INTEGER;
BEGIN
 If NOT(Pl.primal) Then
  Begin
   CLRSCR;
   GOTOXY(19,8);
   WRITE('PULSA P PARA PASAR A SU FORMA PRIMAL EL P.L');
   GOTOXY(19,9);
   WRITE('U OTRA TECLA PARA VOLVER AL MENU PRINCIPAL.');
   tecla:=UPCASE(READKEY);
   IF tecla='P' THEN
    BEGIN
     { Paso la funcin objetivo a la forma maximizar }
     If Pl.funcion_objetivo.minimizar<3 Then
      Begin
       If Pl.funcion_objetivo.minimizar=1 Then
        Pl.funcion_objetivo.minimizar:=4
       Else
        Pl.funcion_objetivo.minimizar:=3;
       For i:=1 TO 3 DO
        Pl.funcion_objetivo.c[i]:=-Pl.funcion_objetivo.c[i];
      End;

     { Conversin a forma <= }
     For i:=1 TO 3 DO
      IF Pl.restriccion[i].IGUALDAD=0 THEN
       BEGIN
        Pl.restriccion[i].IGUALDAD:=1;
        Pl.restriccion[i].a[1]:=-Pl.restriccion[i].a[1];
        Pl.restriccion[i].a[2]:=-Pl.restriccion[i].a[2];
        Pl.restriccion[i].a[3]:=-Pl.restriccion[i].a[3];
        Pl.restriccion[i].d:=-Pl.restriccion[i].d;
       END;

     { Aplicacin del teorema de la dualidad }
     Pl_aux.funcion_objetivo.minimizar:=Pl.funcion_objetivo.minimizar-2;

     For i:=1 TO 3 DO
      Begin
       Pl_aux.restriccion[i].igualdad:=0;
       Pl_aux.restriccion[i].d:=Pl.funcion_objetivo.c[i];
       Pl_aux.funcion_objetivo.c[i]:=Pl.restriccion[i].d;
       For j:=1 TO 3 DO
        Pl_aux.restriccion[i].a[j]:=Pl.restriccion[j].a[i];
      End;
     Pl:=Pl_aux;
     Pl.primal:=True;
    End;
  End;
 If Pl.primal Then
  Begin
   CLRSCR;
   GOTOXY(28,8);
   WRITE('YA TIENES LA FORMA PRIMAL DEL P.L');
   GOTOXY(19,9);
   WRITE('PULSA UNA TECLA PARA VOLVER AL MENU PRINCIPAL.');
   tecla:=READKEY
  END;
END;

(**************************  PROGRAMA PRINCIPAL  ***************************)
BEGIN
 TEXTCOLOR(7);
 TEXTBACKGROUND(0);
 { Inicializacin de ventanas }
 m_color(7,7*16,15,15,7);
 cabmenu:=nil;
 seleccion:=0;
 cabventanamenu:=nil;
 cabsombra:=nil;
 cabventana:=nil;

 DEFMENU(' MENU PRINCIPAL ',18,6,66,17,MarcoB);
 DEFOPCION('1',' MENU PRINCIPAL ','  1) INICIALIZACION DATOS DEL PROBLEMA LINEAL.','');
 DEFOPCION('2',' MENU PRINCIPAL ','  2) MOSTRAR DATOS DEL PROBLEMA LINEAL.','');
 DEFOPCION('3',' MENU PRINCIPAL ','  3) INTRODUCIR DATOS DEL PROBLEMA LINEAL.','');
 DEFOPCION('4',' MENU PRINCIPAL ','  4) GESTION DE FICHEROS DE DISCO.','');
 DEFOPCION('5',' MENU PRINCIPAL ','  5) PASO DE PROBLEMA PRIMAL A DUAL.','');
 DEFOPCION('6',' MENU PRINCIPAL ','  6) RESOLUCION GRAFICA DEL PROBLEMA LINEAL.','');
 DEFOPCION('7',' MENU PRINCIPAL ','  7) RESOLUCION POR EL METODO SIMPLEX.','');
 DEFOPCION('8',' MENU PRINCIPAL ','  8) COMPARACION ENTRE RESULTADOS.','');
 DEFOPCION('A',' MENU PRINCIPAL ','  A) MANUAL DE AYUDA.','');
 DEFOPCION('S',' MENU PRINCIPAL ','  S) SALIR AL SISTEMA OPERATIVO.','');
 DEFMENU(' OBJETIVO ',9,posicion+6,23,posicion+11,MARCOB);
 DEFOPCION('1',' OBJETIVO ',' 1) +Minimo. ','');
 DEFOPCION('2',' OBJETIVO ',' 2) -Minimo. ','');
 DEFOPCION('3',' OBJETIVO ',' 3) +Mximo. ','');
 DEFOPCION('4',' OBJETIVO ',' 4) -Mximo  ','');
 DEFMENU(' MOSTRAR DATOS ',55,16,77,19,MARCOB);
 DEFOPCION('1',' MOSTRAR DATOS ','  1) POR PANTALLA.','');
 DEFOPCION('2',' MOSTRAR DATOS ','  2) POR IMPRESORA.','');
 DEFMENU(' PRIMAL <=> DUAL ',55,16,77,19,MARCOB);
 DEFOPCION('1',' PRIMAL <=> DUAL ','  1) PRIMAL A DUAL.','');
 DEFOPCION('2',' PRIMAL <=> DUAL ','  2) DUAL A PRIMAL.','');

 (***              FIN DE DEFINICION DE VENTANAS-MENUS                 ***)
 {
 Funcion para convertir archivo de TXT a .DAT
 CONVERTIR;
 }

 Inicializar_PL;
 Inicializar_menu_ficheros;
 WINDOW(1,1,80,25);
 CLRSCR;
 WRITESTR(22,1,'RESOLUCION GRAFICA DE PROBLEMAS LINEALES.',15);
 WRITECHAR(1,2,80,'',7);
 WRITECHAR(1,23,80,'',7);
 WRITESTR(35,24,'  (C) 1999 DCCIA',15);
 WINDOW(1,3,80,22);
 REPEAT
  CLRSCR;
  ACTIVARMENU(' MENU PRINCIPAL ');
  IF NOT(seleccion IN [2,5]) THEN
    DESACTIVARMENU;
  CASE seleccion OF
    1:Inicializar_Pl_Con_Verificacion;
    2:BEGIN
       ActivarMenu(' MOSTRAR DATOS ');
       CASE seleccion OF
        1:BEGIN
           DesactivarMenu;
           DesactivarMenu;
           Mostrar_Pl_Pantalla;
           If Pl.primal Then
            cadena_aux:='PRIMAL'
           Else
            cadena_aux:='DUAL';
           WRITESTR(22,posicion+1,'MOSTRAR DATOS DEL P.L '+cadena_aux+' POR PANTALLA',7);
           GOTOXY(20,19);
           WRITE('PULSA UNA TECLA PARA VOLVER AL MENU PRINCIPAL');
           tecla:=READKEY;
           tecla:=' ';
          END;
        2:BEGIN
           Mostrar_Pl_Impresora;
           DesactivarMenu;
           DesactivarMenu;
          END;
       End;
       DesactivarMenu;
      END;
    3:Leer_Pl;
    4:Gestor_de_ficheros;
    5:BEGIN
       ActivarMenu(' PRIMAL <=> DUAL ');
       DesactivarMenu;
       DesactivarMenu;
       CASE seleccion OF
        1:PASO_A_DUAL;
        2:PASO_A_PRIMAL;
       End;
       DesactivarMenu;
      END;
    6:BEGIN
       Resolucion_grafica;
       WINDOW(1,1,80,25);
       CLRSCR;
       WRITESTR(22,1,'RESOLUCION GRAFICA DE PROBLEMAS LINEALES.',15);
       WRITECHAR(1,2,80,'',7);
       WRITECHAR(1,23,80,'',7);
       WRITESTR(35,24,'  (C) 1999 DCCIA',15);
       WINDOW(1,3,80,22);
      END;
    7:Mensaje(1,10,79,15,0,' ESTE MODULO NO ESTA DISPONIBLE TODAVIA ');
    8:Mensaje(1,10,79,15,0,' ESTE MODULO NO ESTA DISPONIBLE TODAVIA ');
    9:MOSTRAR_AYUDA;
  END;
 UNTIL seleccion=10;
 DESACTIVARMENU;
 WINDOW(1,1,80,25);
 CLRSCR;
END.
