(***************************************************************************)
(*                                                                         *)
(*                       UNIDAD DE UTILIDADES                              *)
(*                      ELCHE 1 OCTUBRE DE 1992                            *)
(*                  AUTOR: FRANCISCO JOSE MORA LIZAN                       *)
(*                                                                         *)
(*            ES UTILIZADA EN PL.PAS, RG.PAS Y FICHERO.PAS                 *)
(*                                                                         *)
(***************************************************************************)
Unit Utiles;

Interface

Uses Crt,Win,Dos;

Type
    Opcion=^nodoopcion;
    nodoopcion=Record
                 numero:char; { identificador de la opcion }
                 Prompt,Mensaje:String;
                 sig,ant:Opcion;
               end;
    Menu=^nodomenu;
    nodomenu=Record
               nombre:string;
               x1,y1,x2,y2,NumOpc:Byte;
               caja:FrameChars;
               Opc:Opcion;
               sig:Menu;
             end;
    VentanaMenu=^nodoventanamenu;
    nodoventanamenu=Record
                  nombre:string;
                  sig:VentanaMenu;
                  estado:WinState;
                  CajaAtrib:byte;
                  Buffer:Pointer;
                end;
    Ventana=^nodoventana;
    nodoventana=Record
                  nombre:string;
                  sig:Ventana;
                  x1,y1,x2,y2:byte;
                  estado:WinState;
                  color:byte;
                  Buffer:Pointer;
                end;

var escape,arriba,abajo:boolean;
    c_normal,c_seleccion,
    c_mensaje,c_titulo,c_caja:byte;
    a:byte;
    CabMenu:Menu;
    CabVentanaMenu,CabSombra:VentanaMenu;
    CabVentana:Ventana;
    Seleccion:byte;

Procedure Inicializar;
Procedure LeerCadena(x,y,longitud,color:INTEGER;VAR cadena:STRING;VAR tecla:CHAR);
Function  Real_a_Cadena(numero:REAL;longitud:INTEGER;con_signo,relleno:BOOLEAN):STRING;
Procedure LeerNumero(x,y,longitud,color:INTEGER;VAR numero:REAL;VAR tecla:CHAR);
Procedure Mensaje(x1,y1,x2,y2,error:BYTE;mensaje:STRING);
Procedure M_Color(n,s,me,t,c:byte);
Procedure DefMenu(N:string;x1,y1,x2,y2:byte;B:FrameChars);
Procedure DefOpcion(num:char;N,Pr,M:string);
Procedure ActivarMenu(N:string);
Procedure DesactivarMenu;
Procedure AbrirVentana(N:string;x1,y1,x2,y2:byte;b:FrameChars);
Procedure CerrarVentana;
Procedure DefVentana(N:string;x1,y1,x2,y2,color:byte);
Procedure ActivarVentana(N:string);
Procedure DesactivarVentana(N:string);
Function Reloj:string;
Function Formato(cad:string):string;
Procedure Ocultar;
Procedure Mostrar;

Implementation

var TempCursor:integer;

Procedure SetCursor(NC:Integer);
var reg:Registers;
begin
  with reg do
  begin
    AH:=1;
    BH:=0;
    CX:=NC;
    Intr($10,reg);
  end;
end;

Function GetCursor:integer;
var reg:registers;
begin
  with reg do
  begin
    AH:=3;
    BH:=0;
    Intr($10,reg);
    GetCursor:=CX;
  end;
end;

Procedure Ocultar;
begin
  TempCursor:=GetCursor;
  SetCursor($2000);
end;

Procedure Mostrar;
begin
  SetCursor(TempCursor);
end;

Procedure Inicializar;
begin
  CabMenu:=nil;seleccion:=0;CabVentanaMenu:=nil;CabSombra:=nil;
  CabVentana:=nil;
end;

PROCEDURE LeerCadena(x,y,longitud,color:INTEGER;VAR cadena:STRING;VAR tecla:CHAR);
VAR
 posicion,numero,l,m:INTEGER;
 insertar,salir,tecla_especial:BOOLEAN;
BEGIN
 Tempcursor:=Getcursor;
 Insertar:=FALSE;
 WHILE (keypressed) DO
  tecla:=READKEY;
 TEXTATTR:=color*16;
 GotoXY(x,y);
 FOR l:=1 to LONGITUD DO
  WRITE(' ');
 TEXTATTR:=color;
 posicion:=LENGTH(cadena)+1;
 salir:=FALSE;
 tecla_especial:=FALSE;
 REPEAT
  tecla_especial:=FALSE;
  GOTOXY(x,y);
  WRITE(cadena);
  GOTOXY(x+posicion-1,y);
  tecla:=READKEY;
  CASE tecla OF
   #8:  IF (posicion>1) THEN
         BEGIN
          posicion:=posicion-1;
          DELETE(cadena,posicion,1);
          GOTOXY(x,y);
          WRITE(cadena);
          TEXTATTR:=color*16;
          WRITE(' ');
          TEXTATTR:=color;
         END;
   #0:  BEGIN
         tecla:=READKEY;
         tecla_especial:=TRUE;
         CASE tecla  OF
          #77: IF posicion<=LENGTH(cadena) THEN
                posicion:=posicion+1;
          #75: IF posicion>1 THEN
                posicion:=posicion-1;
          #71: posicion:=1;
          #79: posicion:=LENGTH(cadena)+1;
          #82: BEGIN
                INSERTAR:=NOT(INSERTAR);
                IF insertar THEN
                 SETCURSOR($0007)
                ELSE
                 SETCURSOR(Tempcursor);
               END;
          #83: BEGIN
                DELETE(cadena,posicion,1);
                GOTOXY(x,y);
                WRITE(cadena);
                TEXTATTR:=color*16;
                WRITE(' ');
                TEXTATTR:=color;
               END;
           ELSE salir:=TRUE;
         END;
        END;
   ELSE
        IF (LENGTH(cadena)<longitud) AND (tecla>=#32) THEN
         BEGIN
          IF posicion>LENGTH(cadena) THEN
           cadena:=cadena+tecla
          ELSE
           IF posicion<=LENGTH(cadena) THEN
            IF (insertar) THEN
             BEGIN
              INSERT(tecla,cadena,posicion);
              cadena:=COPY(cadena,1,longitud);
             END
            ELSE
             cadena[posicion]:=tecla;
           IF posicion<=longitud THEN
            posicion:=posicion+1;
         END;
  END; { Del Case }
 UNTIL ((tecla=#27) OR (tecla=#13) OR (tecla_especial AND ((tecla=#80) OR (tecla=#72))) OR (SALIR));
 TEXTATTR:=color;
 GotoXY(x,y);
 FOR l:=1 to LONGITUD DO
  WRITE(' ');
 GOTOXY(x,y);
 WRITE(cadena);
 SETCURSOR(Tempcursor);
END;

FUNCTION Real_a_Cadena(numero:REAL;longitud:INTEGER;con_signo,relleno:BOOLEAN):STRING;
VAR
 i:INTEGER;
 cadena,cadena_aux:STRING;
BEGIN
 { Conversin de Real a Cadena }
 STR(numero:longitud:longitud,cadena_aux);
 DELETE(cadena_aux,1,POS('.',cadena_aux));
 i:=LENGTH(cadena_aux);
 WHILE (i>0) AND (cadena_aux[i]='0') DO
  Begin
   DELETE(cadena_aux,i,1);
   i:=i-1;
  End;
 STR(numero:longitud:0,cadena);
 WHILE (LENGTH(cadena)>0) AND (cadena[1]=' ') DO
  DELETE(cadena,1,1);

 { Aadir signo +, si con_signo=TRUE }
 If con_signo AND (numero>=0) THEN
  cadena:='+'+cadena;
 { Quitamos el signo - si con_signo=FALSE }
 If NOT(con_signo) AND (numero<0) Then
  DELETE(cadena,1,1);

 If cadena_aux<>'' Then
  cadena:=cadena+'.'+cadena_aux;
 If cadena[1]='.' Then
  cadena:='0'+cadena;

 { Rellenamos con blancos el resto de la longitud }
 If relleno THEN
  Begin
   i:=LENGTH(cadena);
   WHILE (i<=longitud) DO
    Begin
     cadena:=cadena+' ';
     i:=i+1;
    End;
  End;
 { Devolucin de la cadena creada }
 Real_a_cadena:=cadena;
END;

PROCEDURE LeerNumero(x,y,longitud,color:INTEGER;VAR numero:REAL;VAR tecla:CHAR);
VAR
 posicion,l,m:INTEGER;
 insertar,salir,tecla_especial,positivo:BOOLEAN;
 cadena:STRING;
BEGIN
 positivo:=(numero>=0);
 cadena:=Real_a_cadena(numero,longitud,FALSE,FALSE);

 Tempcursor:=Getcursor;
 Insertar:=FALSE;
 posicion:=LENGTH(cadena)+1;
 salir:=FALSE;
 tecla_especial:=FALSE;

 { Vaciado de teclas en buffer }
 WHILE (keypressed) DO
  tecla:=READKEY;

 TEXTATTR:=color*16;
 GotoXY(x,y);
 FOR l:=1 to LONGITUD DO
  WRITE(' ');
 TEXTATTR:=color;

 REPEAT
  If (cadena[1]='0') AND (cadena[2]<>'.') THEN
   Begin
    { Borra el contenido del trozo de pantalla ocupado por cadena }
    TEXTATTR:=color*16;
    GotoXY(x,y);
    FOR l:=1 to LONGITUD DO
    WRITE(' ');
    TEXTATTR:=color;

    { Clculo de la nueva cadena (suprimiendo 0 iniciales) }
    VAL(cadena,numero,l);
    cadena:=Real_a_cadena(numero,longitud,FALSE,FALSE);
    If tecla='.' Then
     cadena:=cadena+'.';
    IF posicion>LENGTH(cadena)+1 Then
     posicion:=LENGTH(cadena)+1;
   End;

  If cadena[1]='.' Then
   Begin
    Cadena:='0'+cadena;
    cadena:=COPY(cadena,1,longitud);
    posicion:=3;
   End;

  { Escritura en pantalla de la cadena }
  GOTOXY(x-1,y);
  If positivo Then
   WRITE('+')
  Else
   WRITE('-');
  If cadena<>'' Then
   WRITE(cadena)
  Else
   WRITE('0');
  GOTOXY(x+posicion-1,y);
  tecla:=READKEY;
  CASE tecla OF
   #8:  IF (posicion>1) THEN
         BEGIN
          posicion:=posicion-1;
          DELETE(cadena,posicion,1);
          GOTOXY(x,y);
          WRITE(cadena);
          TEXTATTR:=color*16;
          WRITE(' ');
          TEXTATTR:=color;
         END;
   #0:  BEGIN
         tecla:=READKEY;
         tecla_especial:=TRUE;
         CASE tecla  OF
          #77: IF posicion<=LENGTH(cadena) THEN
                posicion:=posicion+1
               Else
                salir:=TRUE;
          #75: IF posicion>1 THEN
                posicion:=posicion-1
               Else
                salir:=TRUE;
          #71: posicion:=1;
          #79: posicion:=LENGTH(cadena)+1;
          #82: BEGIN
                INSERTAR:=NOT(INSERTAR);
                IF insertar THEN
                 SETCURSOR($0007)
                ELSE
                 SETCURSOR(Tempcursor);
               END;
          #83: BEGIN
                DELETE(cadena,posicion,1);
                GOTOXY(x,y);
                WRITE(cadena);
                TEXTATTR:=color*16;
                WRITE(' ');
                TEXTATTR:=color;
               END;
           ELSE salir:=TRUE;
         END;
        END;
   '+','-': POSITIVO:=(tecla = '+');
   ELSE
        IF (LENGTH(cadena)<=longitud) AND ((tecla IN ['0'..'9']) OR ((tecla='.') AND (POS('.',cadena)=0))) THEN
         BEGIN
          IF (posicion>LENGTH(cadena)) AND (LENGTH(cadena)<longitud) THEN
           cadena:=cadena+tecla
          ELSE
           IF posicion<=LENGTH(cadena) THEN
            IF (insertar) Then
             Begin
              INSERT(tecla,cadena,posicion);
              cadena:=COPY(cadena,1,longitud);
             End
            ELSE
             cadena[posicion]:=tecla;
          IF posicion<=longitud THEN
           posicion:=posicion+1;
         END;
  END; { Del Case }
 UNTIL ((tecla=#27) OR (tecla=#13) OR (tecla_especial AND ((tecla=#80) OR (tecla=#72))) OR (salir));

 VAL(cadena,numero,l);
 If NOT(positivo) Then
  numero:=-numero;
 GOTOXY(x-1,y);
 WRITE(Real_a_cadena(numero,longitud,TRUE,TRUE));
 SETCURSOR(Tempcursor);

END;

{ Procedimiento para mostrar un mensaje }
Procedure Mensaje(x1,y1,x2,y2,error:BYTE;mensaje:STRING);
Var
 cadena,cadena_aux:STRING;
 tecla:CHAR;
Begin
 If error>0 THEN
  Begin
   cadena:=' DE ERROR ';
   STR(error,cadena_aux);
   Case error Of
      2: mensaje:='ARCHIVO NO ENCONTRADO';
      3: mensaje:='CAMINO NO ENCONTRADO';
      5: mensaje:='ACCESO DENEGADO';
      6: mensaje:='MANEJADOR INCORRECTO';
      8: mensaje:='NO HAY SUFICIENTE MEMORIA';
     10: mensaje:='ENTORNO INCORRECTO';
     11: mensaje:='FORMATO INVALIDO';
     18: mensaje:='NO HAY ARCHIVOS CON ESE NOMBRE';
    152: mensaje:='DISCO NO PREPARADO';
    Else mensaje:='ERROR NUMERO '+cadena_aux;
   End; { Del case };
  End
 Else
  cadena:='';
 If LENGTH(mensaje)>x2-x1 Then
  mensaje:=COPY(mensaje,1,x2-x1-1);
 AbrirVentana(' MENSAJE '+cadena,x1,y1,x2,y2,MarcoB);
 Write(#7);
 Clrscr;
 GotoXY((x2-x1-LENGTH(mensaje)) DIV 2,(y2-y1) DIV 2);
 Write(mensaje);
 If (x2-x1-16>0) AND (y2-y1>2) Then
  Begin
   GotoXY((x2-x1-16) DIV 2,(y2-y1) DIV 2+1);
   Write('PULSA UNA TECLA.');
  End;
 tecla:=READKEY;
 CerrarVentana;
End;

Procedure M_Color(n,s,me,t,c:byte);
begin
     c_normal:=n;
     c_seleccion:=s;
     c_mensaje:=me;
     c_titulo:=t;
     c_caja:=c;
end;

Procedure DefMenu(N:string;x1,y1,x2,y2:byte;B:FrameChars);
var p,q:Menu;
begin
  new(p);
  p^.nombre:=N;
  p^.x1:=x1; p^.y1:=y1;
  p^.x2:=x2; p^.y2:=y2;
  p^.caja:=B;
  p^.NumOpc:=0;
  p^.opc:=nil;
  p^.sig:=nil;
  If CabMenu=nil
     then CabMenu:=p
     else begin
            q:=CabMenu;
            while q^.sig<>nil do q:=q^.sig;
            q^.sig:=p;
          end;
end;

Procedure DefOpcion(num:char;N,Pr,M:string);
Var p,q:Opcion;
      h:Menu;
begin
  new(p);
  with p^ do begin
    numero:=num;
    Prompt:=Pr;
    Mensaje:=M;
  end;
  h:=CabMenu;
  While h^.nombre<>N do h:=h^.sig;
  While length(p^.prompt)<(h^.x2-h^.x1-1) do p^.prompt:=p^.prompt+' ';
  If h^.opc=nil then
    begin
      h^.opc:=p;
      h^.opc^.sig:=h^.opc;
      h^.opc^.ant:=h^.opc;
    end
  else
    begin
      q:=h^.opc;
      while q^.sig<>h^.opc do q:=q^.sig;
      q^.sig:=p;
      p^.ant:=q;
      p^.sig:=h^.opc;
      h^.opc^.ant:=p;
    end;
  inc(h^.NumOpc);
end;

Procedure AbrirVentana(N:string;x1,y1,x2,y2:byte;b:FrameChars);
var V,S:VentanaMenu;
    i,j:integer;
begin
  new(S);
  with S^ do begin
    nombre:=N;
    sig:=CabSombra;
    SaveWin(estado);
    window(x1+1,y1+1,x2+1,y2+1);
    CajaAtrib:=c_caja;
    GetMem(Buffer,WinSize);
    ReadWin(Buffer^);
    FillWin(#176,c_normal);
  end;
  CabSombra:=S;
  new(V);
  with V^ do begin
    nombre:=N;
    sig:=CabVentanaMenu;
    SaveWin(estado);
    window(x1,y1,x2,y2);
    CajaAtrib:=c_caja;
    GetMem(Buffer,WinSize);
    ReadWin(Buffer^);
    FrameWin(nombre,b,7,c_caja);
  end;
  CabVentanaMenu:=V;
End;

Procedure AcMensaje(M:string;x1,y1,x2,y2:byte);
begin
    window(2,24,79,24);
    ClrEol;
    writestr((80-length(M))div 2,1,M,c_mensaje);
    window(x1+1,y1+1,x2-1,y2-1);
end;

Procedure ActivarMenu(N:string);
var p:Menu;
    q:Opcion;
    c:char;
    cjto:set of char;
    hecho:boolean;
Begin
  cjto:=[]; hecho:=false;
  Ocultar;
  p:=CabMenu;
  while p^.nombre<>N do p:=p^.sig;
  with p^ do begin
    If NOT(CabVentanaMenu^.nombre=nombre) then
    begin
      AbrirVentana(nombre,x1,y1,x2,y2,caja);
    end;
    TextAttr:=c_normal;
    ClrScr;
    If opc<>nil then
      begin
        q:=opc;a:=1;
        repeat
          writestr(1,a,q^.Prompt,c_normal);
          cjto:=cjto+[q^.numero];
          q:=q^.sig;
          inc(a);
        until q=opc;
        a:=1;
        while (q^.mensaje='SKIP') and (q^.sig<>opc) do
          begin
            q:=q^.sig;
            inc(a);
          end;
        If q^.mensaje<>'SKIP' then
          writestr(1,a,q^.Prompt,c_seleccion);
        Repeat
          c:=UPCASE(readkey);
          case c of
             #0: case Readkey of
                      #72:begin
                            writestr(1,a,q^.Prompt,c_normal);
                            repeat
                              q:=q^.ant;
                              If a=1 then a:=NumOpc
                                     else dec(a);
                            until q^.mensaje<>'SKIP';
                            writestr(1,a,q^.Prompt,c_seleccion);
                          end;
                      #80:begin
                            writestr(1,a,q^.Prompt,c_normal);
                            repeat
                              q:=q^.sig;
                              If a=NumOpc then a:=1
                                          else inc(a);
                            until q^.mensaje<>'SKIP';
                            writestr(1,a,q^.Prompt,c_seleccion);
                          end;
{                      #75:begin
                            Seleccion:=0;
                            c:=#27;
                          end;
                      #77:begin
                            Seleccion:=a;
                            writestr(1,a,q^.Prompt,c_titulo);
                            c:=#13;
                          end;}
                end;
             #13:begin
                   Seleccion:=a;
                   writestr(1,a,q^.Prompt,c_titulo);
                 end;
             #27:Seleccion:=0;
            else begin
                   if c in cjto then begin
                     if c<>q^.numero then begin
                                      writestr(1,a,q^.Prompt,c_normal);
                                      repeat
                                        q:=q^.sig;
                                        If a=NumOpc then a:=1
                                                    else inc(a);
                                      until q^.numero=c;
                                    end;
                     Seleccion:=a;
                     writestr(1,a,q^.Prompt,c_titulo);
                     c:=#13;
                  end;
                end;
        end;
        until (c=#13) or (c=#27);
      end;
    end;
    Mostrar;
end;

Procedure DesactivarMenu;
var V,S:VentanaMenu;
begin
  If CabVentanaMenu<>nil then begin
    V:=CabVentanaMenu;
    with V^ do begin
      UnFrameWin;
      WriteWin(Buffer^);
      FreeMem(Buffer,WinSize);
      RestoreWin(estado);
      CabVentanaMenu:=sig;
    end;
    Dispose(V);
    S:=CabSombra;
    with S^ do begin
      WriteWin(Buffer^);
      FreeMem(Buffer,WinSize);
      RestoreWin(estado);
      CabSombra:=sig;
    end;
    Dispose(S);
  end;
end;

Procedure CerrarVentana;
begin
 DesactivarMenu;
end;

Procedure DefVentana(N:string;x1,y1,x2,y2,color:byte);
var p,q:Ventana;
begin
  new(p);
  p^.nombre:=N;
  p^.x1:=x1; p^.y1:=y1;
  p^.x2:=x2; p^.y2:=y2;
  p^.color:=color;
  p^.sig:=nil;
  If CabVentana=nil then CabVentana:=p
  else begin
         q:=CabVentana;
         while q^.sig<>nil do q:=q^.sig;
         q^.sig:=p;
       end;
end;

Procedure ActivarVentana(N:string);
var p:Ventana;
begin
  p:=CabVentana;
  while p^.nombre<>N do p:=p^.sig;
  with p^ do begin
    SaveWin(estado);
    window(x1,y1,x2,y2);
    GetMem(Buffer,WinSize);
    ReadWin(Buffer^);
    TextAttr:=color;
    ClrScr;
  end;
end;

Procedure DesactivarVentana(N:string);
var p:Ventana;
begin
  p:=CabVentana;
  while p^.nombre<>N do p:=p^.sig;
  with p^do begin
    WriteWin(Buffer^);
    FreeMem(Buffer,WinSize);
    RestoreWin(estado);
  end;
end;

Function Reloj:string;

Var h,m,s,c:Word;
    d,me,a,d2:Word;
    h1,m1,s1,c1,
    d1,me1,a1:string[2];
Begin
  GetTime(h,m,s,c);
  str(h,h1);str(m,m1);str(s,s1);str(c,c1);
  GetDate(a,me,d,d2);
  a:=a-1900;
  str(a,a1);str(me,me1);str(d,d1);
  if length(d1)=1 then d1:='0'+d1;
  if length(me1)=1 then me1:='0'+me1;
  Reloj:=d1+'-'+me1+'-'+a1;
End;

Function Formato(cad:string):string;
var l,i:byte;
begin
  l:=length(cad);
  for i:=1 to (l div 3) do
     if l>(3*i) then insert('.',cad,l-(3*i)+1);
  Formato:=cad;
end;

Function LeeNumero(x,y,ncar,color1,color2:byte):string;
var c    :char;
    T,T1 :string;
    T2   :byte;
    Hecho:boolean;
Begin
  TextAttr:=color1;
  T:=''; T1:=''; T2:=0; Hecho:=false; Escape:=False;
  Arriba:=false; Abajo:=false;
  Repeat
    GotoXY(x+ncar-1,y);
    C:=ReadKey;
    If T2=0 then writechar(x,y,ncar,' ',c_seleccion);
    Case C of
         #0: begin
               case readkey of
                 #72: Arriba:=true;
                 #80: Abajo:=true;
               end;
               T:='';
             end;
         #8: If T2>0 then begin
               T:=copy(T,1,Length(T)-1);
               T1:=Formato(T);
               T2:=length(T1);
               GotoXY(x,y);
               write(T1:ncar);
             end;
        #13: Hecho:=true;
        #27: begin
               T1:='';
               escape:=true;
             end;
   #48..#57: If T2<ncar then begin
                 T:=T+C;
                 T1:=Formato(T);
                 T2:=length(T1);
                 gotoxy(x,y);
                 write(T1:ncar);
               end;
      end;
  Until Hecho or Escape or Arriba or Abajo or (T2=ncar);
  WriteChar(x,y,ncar,' ',color2);
  WriteStr(x+(ncar-length(T1)),y,T1,color2);
  LeeNumero:=T;
end;

END.

